<?php

namespace Drupal\social_graphql\Plugin\GraphQL\Fields\Twitter;

use Drupal\graphql\GraphQL\Execution\ResolveContext;
use Drupal\graphql\Plugin\GraphQL\Fields\FieldPluginBase;
use GraphQL\Type\Definition\ResolveInfo;

/**
 * @GraphQLField(
 *   id = "social_graphql_twitter_post_fields",
 *   secure = true,
 *   name = "socialGraphQLTwitterPostFields",
 *   deriver =
 *   "Drupal\social_graphql\Plugin\Deriver\Twitter\Fields\SocialGraphQLTwitterPostFieldsDeriver"
 * )
 */
class SocialGraphQLTwitterPostField extends FieldPluginBase {

  /**
   * {@inheritdoc}
   */
  public function resolveValues($value, array $args, ResolveContext $context, ResolveInfo $info) {
    // If user is request, get user into the post.
    if ($info->parentType->name == 'SocialGraphQLTwitterPost' && $info->returnType->name == 'SocialGraphQLTwitterUser') {
      if (!empty($value['post']->user)) {

        yield  [
          'type' => 'SocialGraphQLTwitterUser',
          'user' => $value['post']->user,
        ];
      }
      else {
        // Empty user.
        yield  [
          'type' => 'SocialGraphQLTwitterUser',
          'user' => '',
        ];
      }
    }
    else {
      // Get the field value.
      $definition = $this->getPluginDefinition();
      if (!empty($value['post']->{$definition['field_name']})) {
        yield $value['post']->{$definition['field_name']};
      }
      else {
        yield '';
      }
    }


  }

}
